//
//  CHTrialReminder.h
//  Fontcase
//
//  Created by Pieter Omvlee on 1/15/09.
//  Copyright 2009 Bohemian Coding. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import <Chocolat/Chocolat.h>

#import "CHRegistration.h"

FOUNDATION_STATIC_INLINE NSString *CHAppVersion()
{
  return [[[NSBundle mainBundle] infoDictionary] objectForKey:@"CFBundleVersion"];
}

FOUNDATION_STATIC_INLINE NSString *CHTrialSaveName()
{
  return [@"trialExpire-" stringByAppendingString:[CHAppVersion() substringToIndex:MIN([CHAppVersion() length],3)]];
}

FOUNDATION_STATIC_INLINE int CHTrialRemainingDays()
{
  NSCalendarDate *date = [[NSCalendarDate calendarDate] dateByAddingYears:0 months:0 days:30 hours:0 minutes:0 seconds:0];
  [NSUserDefaultsController registerObject:[NSKeyedArchiver archivedDataWithRootObject:date] forKey:CHTrialSaveName()];
  
  NSUserDefaults *defs       = [[NSUserDefaultsController sharedUserDefaultsController] defaults];
  NSCalendarDate *expireDate = [NSKeyedUnarchiver unarchiveObjectWithData:[defs valueForKey:CHTrialSaveName()]];
  NSCalendarDate *today      = [NSCalendarDate calendarDate];
  
  return (int)([expireDate dayOfCommonEra] - [today dayOfCommonEra]);
}

@interface CHTrialReminder : CHSheetController
{
  IBOutlet NSWindow *window;
}
- (void)run;
- (void)terminate;

- (IBAction)quit:(id)sender;
- (IBAction)close:(id)sender;
- (IBAction)purchase:(id)sender;
- (IBAction)registrate:(id)sender;

@end
